//Author: A.Vinci (mercurio@altrove.cjb.net)
//Second Author: Kornel Misiejuk (lenrock@2p.pl)
//costanti
 const NS_PROCESS_CONTRACTID         = "@mozilla.org/process/util;1"
 const NS_LOCAL_FILE_CONTRACTID = "@mozilla.org/file/local;1";
 const nsIFile            = Components.interfaces.nsIFile;
 const nsILocalFile       = Components.interfaces.nsILocalFile;
 const C                 = Components;

HTTRACK_PATH = getChromeDir("\\spiderzilla\\content\\httrack\\") + "httrack.exe";
const DIRSEPARATOR = "\\";
const TOTAL_DECKS = 2;
//Accesses to spiderzilla.properties
function getString(stringName){
	return document.getElementById("spiderstrings").getString(stringName);
}   

//This functions change window's content. 
//I use "stack" since "deck" doesn't work on 0.9.9
function showDeck(Index){
	for (var n = 0;n<TOTAL_DECKS;n++)
		el("deck-"+n).collapsed=1;
	el("deck-"+Index).collapsed=0;
}

//Contestual help for Action menu
function setActionHelp() {
	var res= "actionhelp" + document.getElementById("MlActionList").value;
	document.getElementById("DActionHelp").value = getString(res);
}

//Init the program
function startProgram(){
	if(window.arguments)
	 el("TbWebAddresses").value = window.arguments[0];
	if(!el("TbBaseDir").statusText)
	 el("TbBaseDir").statusText = getString("StandardDir");
	el("TbBaseDir").value = el("TbBaseDir").statusText;
	if(!el("Tbproxyset").statusText)
	 el("Tbproxyset").statusText = getString("Standardproxy");
	el("Tbproxyset").value = el("Tbproxyset").statusText;
	setActionHelp();

 for(var n = 1; n<=10;n++){
  el("MlExternalDepth").appendItem ( n ,n); 
  el("MlDepth").appendItem ( n ,n);
  el("MlNrRetries").appendItem ( n ,n);
 }

// changeSaveToLabel();
}

function exitProgram(){
   el("TbBaseDir").statusText = el("TbBaseDir").value;
   el("Tbproxyset").statusText = el("Tbproxyset").value;
   window.close()
}




//Other
function selectBaseFolder(){
	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Selectionner le dossier de racine", nsIFilePicker.modeGetFolder);
	
	if (fp.show() == nsIFilePicker.returnOK)
	{
		var path = fp.file.path;
		document.getElementById("TbBaseDir").value = path;
	}
	el("TbBaseDir").statusText = el("TbBaseDir").value;
}

function getValue(id){
	return document.getElementById(id).value;
}

function executeFile(executable, args) {
  dump("Protozilla: fichier .exe: ("+args.length+") "+executable.path+" "+args.join(" ")+"\n");

  if (!executable.exists()) {
    alert("Protozilla: fichier .exe: Erreur - l'excutable '"+executable.path+"' n'a pu tre trouv\n");
    return false;
  }

  try {
    var process = Components.classes[NS_PROCESS_CONTRACTID].createInstance(Components.interfaces.nsIProcess);

    process.init(executable);

    var pid = new Object();
    process.run(false, args, args.length, pid);
    
  } catch (ex) {
    dump("Erreur lors de l'excution de "+executable.path+" \n");
    return false;
  }

  return true;
}

function getChromeDir(subdir) {
	var dir   = new C.Constructor("@mozilla.org/file/directory_service;1", "nsIProperties");
    rv        = (new dir()).get("AChrom", C.interfaces.nsIFile).path;
	return  rv + subdir;
}

//Builds command line 
function startDownload(){
	
	if(!getValue("TbProjectName")){
		alert("Entrer le nom du projet");
		return;
	}
	if(!getValue("TbWebAddresses")){
		alert("Entrer l'adrese web");
		return;
	}
	
	
	var param = new Array;
	var i=0;

	if(document.getElementById("MlActionList").value)
	{
	var mir=0;
	var wizd=1;
	var sep=2;
	var mirlin=3;
	var testlin=4;
	var skel=5;
	var conti=6;
	var updat=7;
	
	if(document.getElementById("MlActionList").value == mir)
	param[i++] = "--mirror";
	if(document.getElementById("MlActionList").value == wizd)
	param[i++] = "--mirror-wizard";
	if(document.getElementById("MlActionList").value == sep)
	param[i++] = "--get-files";
	if(document.getElementById("MlActionList").value == mirlin)
	param[i++] = "--mirrorlinks";
	if(document.getElementById("MlActionList").value == testlin)
	param[i++] = "--spider";
	if(document.getElementById("MlActionList").value == skel)
	param[i++] = "--skeleton";
	if(document.getElementById("MlActionList").value == conti)
	param[i++] = "--continue";
	if(document.getElementById("MlActionList").value == updat)
	param[i++] = "--update";
	}

	param[i++] = getValue("TbWebAddresses"); 
	param[i++] = "-O" ;
	param[i++] = getValue("TbBaseDir") +DIRSEPARATOR + getValue("TbProjectName");
	if(document.getElementById("Tbproxyset").value)
	{
	param[i++] = "-P" ;
	param[i++] = getValue("Tbproxyset");
	}

	//Rules**********************************************************
	 if(document.getElementById("MlDepth").value)
	  param[i++] = "-r" + document.getElementById("MlDepth").value;
	 if(document.getElementById("MlExternalDepth").value)
	  param[i++] = "-%e" + document.getElementById("MlExternalDepth").value;
	 if(document.getElementById("TbMaxNonHTMLSize").value) {
		param[i++] = "-m" + document.getElementById("TbMaxNonHTMLSize").value;
		if(document.getElementById("TbMaxHTMLSize").value)
		param[i-1] = param[i-1]+ "," + document.getElementById("TbMaxHTMLSize").value;
	 }
	 if(document.getElementById("TbMaxSiteSize").value)
	  param[i++] = "-M" + document.getElementById("TbMaxSiteSize").value;
	 if(document.getElementById("TbMaxTime").value)
	  param[i++] = "-E" + document.getElementById("TbMaxTime").value;
	 if(document.getElementById("TbMaxTransRate").value)
	  param[i++] = "-A" + document.getElementById("TbMaxTransRate").value;
	 if(document.getElementById("TbMaxConBySec").value)
	  param[i++] = "-%c" + document.getElementById("TbMaxConBySec").value;
	 if(document.getElementById("TbMaxPause").value)
	  param[i++] = "-G" + document.getElementById("TbMaxPause").value;
	//Flow***********************************************************
	 if(document.getElementById("TbNrMultiCon").value)
	  param[i++] = "-c" + document.getElementById("TbNrMultiCon").value;
	 if(document.getElementById("TbTimeOut").value)
	  param[i++] = "-T" + document.getElementById("TbTimeOut").value;
	 if(document.getElementById("MlNrRetries").value)
	  param[i++] = "-R" + document.getElementById("MlNrRetries").value;
	 if(document.getElementById("TbMinTransRate").value)
	  param[i++] = "-J" + document.getElementById("TbMinTransRate").value;
	 if(document.getElementById("HostControl").value)
	  param[i++] = "-H" + document.getElementById("HostControl").value;
	//Links Option***************************************************
	  if (document.getElementById("CbExParsing").checked)
	  param[i++] = "-%P0" ;
	  if (document.getElementById("CbGetNear").checked)
	  param[i++] = "-n" ;
	  if (document.getElementById("CbTestURL").checked)
	  param[i++] = "-t" ;
	//Spider Option**************************************************
	  if (document.getElementById("CbCookies").checked)
	  param[i++] = "-b0" ;
	  if (document.getElementById("CbParsing").checked)
	  param[i++] = "-j0" ;
	  if (document.getElementById("CbForceHTTP").checked)
	  param[i++] = "-%h" ;
	  if (document.getElementById("CbKeepAlive").checked)
	  param[i++] = "-%k" ;
	  if (document.getElementById("CbTolerReq").checked)
	  param[i++] = "-%B" ;
	  if (document.getElementById("CbUpHacks").checked)
	  param[i++] = "-%s" ;
	//Expert Option**************************************************
	  if (document.getElementById("CbSameDir").checked)
	  param[i++] = "-S" ;
	  if (document.getElementById("CbGoUp").checked)
	  param[i++] = "-U" ;
	  if (document.getElementById("CbGoDown").checked)
	  param[i++] = "-D" ;
	  if (document.getElementById("CbGoBoth").checked)
	  param[i++] = "-B" ;
	  if (document.getElementById("CbSameAddress").checked)
	  param[i++] = "-a" ;
	  if (document.getElementById("CbSamePrin").checked)
	  param[i++] = "-d" ;
	  if (document.getElementById("CbSameTLD").checked)
	  param[i++] = "-l" ;
	  if (document.getElementById("CbGoEvery").checked)
	  param[i++] = "-e" ;
	  if (document.getElementById("CbDebugHead").checked)
	  param[i++] = "-%H" ;

	//LoG Index Cache************************************************
	  if (document.getElementById("CbNoCache").checked)
	  param[i++] = "-C0" ;
	  if (document.getElementById("CbStoreAllCache").checked)
	  param[i++] = "-k" ;
	  if (document.getElementById("CbNotReDown").checked)
	  param[i++] = "-%n" ;
	  if (document.getElementById("CbDisplay").checked)
	  param[i++] = "-%v" ;
	  if (document.getElementById("CbNoLog").checked)
	  param[i++] = "-Q" ;
	  if (document.getElementById("CbQuiet").checked)
	  param[i++] = "-q" ;
	  if (document.getElementById("CbLogExtraInfo").checked)
	  param[i++] = "-z" ;
	  if (document.getElementById("CbLogDebug").checked)
	  param[i++] = "-Z" ;
	  if (document.getElementById("CbLogOnScreen").checked)
	  param[i++] = "-v" ;
	  if (document.getElementById("CbOneLogFile").checked)
	  param[i++] = "-f2" ;
	  if (document.getElementById("CbNoIndex").checked)
	  param[i++] = "-I0" ;
	  if (document.getElementById("CbSearchIndex").checked)
	  param[i++] = "-%I" ;
	//Build Options**************************************************
 	  if(document.getElementById("MlLongName").value)
	  param[i++] = "-L" + document.getElementById("MlLongName").value;
	  if(document.getElementById("MlK").value)
	{
	  var kwart="1"
	  if(document.getElementById("MlK").value == kwart)
	  param[i++] = "-K" ;
	  if(document.getElementById("MlK").value != kwart)
	  param[i++] = "-K" + document.getElementById("MlK").value;
	}
	  if (document.getElementById("CbRepExt").checked)
	  param[i++] = "-x" ;
	  if (document.getElementById("CbNotQueryString").checked)
	  param[i++] = "-%q0" ;
	  if (document.getElementById("CbGenError").checked)
	  param[i++] = "-o0" ;
	  if (document.getElementById("CbKeepDel").checked)
	  param[i++] = "-X0" ;
	  if (document.getElementById("CbASIS").checked)
	  param[i++] = "-%p" ;
	//System********************************************************
	 if (document.getElementById("CbMozUA").checked){
	  param[i++] = "-F"  ;
	  param[i++] = navigator.userAgent ;}  
	//Filters********************************************************
	 var stringbuff = ""; //Get filters
	  if (document.getElementById("CbImages").checked)
	   stringbuff+="+*.gif +*.jpg +*.jpeg +*.gif +*.bmp +*.png";
	  if (document.getElementById("CbArchives").checked)
	   stringbuff+="+*.zip +*.rar +*.tgz +*.gz +*.rar";
	  if (document.getElementById("CbMedia").checked)
	   stringbuff+="+*.mov +*.mpg +*.mpeg +*.mp3 +*.avi +*.asf";
	  stringbuff+=document.getElementById("TbRules").value;
	  var ss = stringbuff.split(" ");
	  for (var n=0;n<ss.length;n++)
	   param[i++] = ss[n];

	
	var httrack = Components.classes[NS_LOCAL_FILE_CONTRACTID].createInstance(nsILocalFile);
    httrack.initWithPath(HTTRACK_PATH);
	executeFile(httrack,param);
}

function el(id){
	return document.getElementById(id);
}
